let player; //variable storing Player object
let obstacles = []; //array storing all obstacle objects
let movingObstacle; //obstacle that moves
let health = 1; //players health
let level = 1; //current game level
let timer = 3600; //time till level switches
let collisionSound; //variable storing collision sound effect


function setup() {
 // put setup code here
 createCanvas(500,500); //canvas size
 player = new Player(); // create player object
 
 // 5 still obstacles in different positions
  obstacles.push(new Obstacle(0, -500));
  obstacles.push(new Obstacle(100, -500));
  obstacles.push(new Obstacle(200, -500));
  obstacles.push(new Obstacle(300, -500));
  obstacles.push(new Obstacle(400, -500));

  movingObstacle = random(obstacles); //randomly chooses an obstacle to move

  
}


function draw() {
  if (health < 1) {
    level = 0; // change to game over screen when health drops to 0
  }

  if (level === 2 && timer <= 0) {
    timer = 3600; //resets timer when level 2 starts
  }
  // switch statement
  switch(level) {
    case 0:
      gameOver(); //show game over screen
      break;

    case 1:
      runGame(); //runs level 1
      break;

    case 2:
      runLevel2(); //runs level 2
      break;


  }
}


function runGame() {
  // put drawing code here
  background (51); //set background colour
  player.update(); //updates players position
  player.show(); //drawing player
  
// loop through each obstacle
  for (let obs of obstacles){
  obs.show(); //draw obstacle
  if (obs === movingObstacle) {
  obs.update(); //move selected moving obstacle
  }
 }
 //check for collisions between player and obstacles
 if (movingObstacle.hits(player)) {
  if(!collisionSound.isPlaying()) {
    collisionSound.play(); //play sound when player collides with object
  }
  console.log("HIT");
  health--; //decrease health
  }


  if (timer <= 0) {
    level = 2; //move to level 2 when timer runs out
  }

  fill(255); //text colour
  textSize(24); //text size on screen
  textAlign(LEFT, CENTER); //position of text
  text("Health: "+health, 10, 30); //health info
  timer--; //decrease timer each frame
  text("Timer: " + floor(timer / 60), 400, 30); //time info in seconds
  text("Level: 1", 200, 30); //show current level

}


function runLevel2() {
  background (51); //background colour
  player.update(); //udate players position
  player.show(); //draw player
  
//loop through each obstacle
  for (let obs of obstacles){
  obs.show(); //draw obstacle
  if (obs === movingObstacle) {
  obs.update(1.5); //move obstacles 1.5 times faster in level 2
  }
 }
//checking for collisions
 if (movingObstacle.hits(player)) {
  if (!collisionSound.isPlaying()) {
    collisionSound.play(); //play collision sound
  }
  console.log("HIT");
  health--; //reduce health
  }


  if (timer <= 0) {
    level = 2; //keep level 2 active till changed
  }
//text on screen info
  fill(255);
  textSize(24);
  textAlign(LEFT, CENTER);
  text("Health: "+health, 10, 30);
  timer--;
  text("Timer: " + floor(timer / 60), 400, 30);
  text("Level: 2", 200, 30);
}

function preload() {
  //load collision sound before sketch starts
  collisionSound = loadSound('1146381.audio-Designed-Misc-Swipe-Electric-Mobile_Games_UI-VADI.wav');
}

 
function gameOver() {
  console.log("gameOver");
  background(175,54,60); //background set red
  fill(255); //text colour white
  textSize(50); //text size
  textAlign(CENTER, CENTER); //text position
  text("GAME OVER", width/2, height/2); //show text on screen
}

function keyPressed() {
  //player moves direction of key pressed
  if (keyCode === RIGHT_ARROW) { //right arrow key
    loop();
    player.moveRight();
  } 
 else if (keyCode === LEFT_ARROW) { //left arrow key
    player.moveLeft();
 }
 else if (keyCode === DOWN_ARROW) { //down arrow key
   player.moveDown();
  }
  else if (keyCode === UP_ARROW) { //up arrow key
    player.moveUp();
  }

}


